HDU 3001 Travelling (状压dp三进制)

来源:互联网 发布:python需要学多久 编辑:程序博客网 时间:2024/06/05 06:39

http://acm.hdu.edu.cn/showproblem.php?pid=3001

Problem Description
After coding so many days,Mr Acmer wants to have a good rest.So travelling is the best choice!He has decided to visit n cities(he insists on seeing all the cities!And he does not mind which city being his start station because superman can bring him to any city at first but only once.), and of course there are m roads here,following a fee as usual.But Mr Acmer gets bored so easily that he doesn’t want to visit a city more than twice!And he is so mean that he wants to minimize the total fee!He is lazy you see.So he turns to you for help.

Input
There are several test cases,the first line is two intergers n(1<=n<=10) and m,which means he needs to visit n cities and there are m roads he can choose,then m lines follow,each line will include three intergers a,b and c(1<=a,b<=n),means there is a road between a and b and the cost is of course c.Input to the End Of File.

Output
Output the minimum fee that he should pay,or -1 if he can’t find such a route.

Sample Input

2 1
1 2 100
3 2
1 2 40
2 3 50
3 3
1 2 3
1 3 4
2 3 10

Sample Output

100
90
7


题意:
n个城市,m条道路。每个城市最少访问一次,最多访问2次。问遍历完所有的城市所需的花费,如果没有这样的路则输出-1。

解题思路:
三进制压缩第一题。总结一下跟二进制的不同。
三进制压缩多了两个数组(以本题为例):

int bit[12]={0,1,3,9,27,81,243,729,2187,6561,19683,59049};//分别是 pow(3,i)的值,方便下面更新stata。若要访问k城市,则state+=bit[k]就将state更新了int tri[60000][11];//表示状态为i时,且第j位的值。这个数组可能的取值只有0,1,2

然后跟其他的状压dp一样。只不过这题不能先用floyed处理,因为限定了每个城市最多访问2次。
第一层遍历状态,第二层遍历已经访问的城市,第三层更新未访问的城市。
状态转移方程为:
dp[k][state] = min(dp[k][state],dp[j][state+bit[k]]+path[j][k]).


#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <climits>#include <cmath>#include <stack>using namespace std;typedef long long LL;int n,m,tot;int path[15][15];int dp[15][60000];int bit[12]={0,1,3,9,27,81,243,729,2187,6561,19683,59049};int tri[60000][11];void Gettri(){    tot = pow(3,10);    for(int i=0;i<tot;i++)     {        int t = i;        for(int j=1;j<=10;j++)        {            tri[i][j] = t % 3;            t/=3;            if( t==0 ) break;        }    }}bool check(int sta){    for(int i=1;i<=n;i++)    {        if( tri[sta][i] == 0) return false;    }    return true;}void Init(){    for(int i=1;i<=n;i++)        for(int j=1;j<=n;j++)            path[i][j] = INT_MAX;}int main(){    Gettri();    while( scanf("%d%d",&n,&m)!=EOF )    {        Init();        while(m--)        {            int u,v,w; cin>>u>>v>>w;            path[u][v] = path[v][u] = min(path[u][v],w);        }        int ans = INT_MAX;        memset(dp,-1,sizeof(dp));        for(int i=1;i<bit[n+1];i++)        {            for(int j=1;j<=n;j++)             {                if( tri[i][j] ) {                     if( i == bit[j] )                      {                         dp[j][i] = 0;                         if(check(i)) ans = min(ans,dp[j][i]);                     }                     for(int k = 1;k<=n;k++)                     {                         if( tri[i][k] !=2 && path[j][k]!=INT_MAX && dp[j][i]!=-1 )                         {                             int sta = i + bit[k];                             if(dp[k][sta]==-1) dp[k][sta] = dp[j][i] + path[j][k];                             else                                 dp[k][sta] = min( dp[k][sta] ,dp[j][i] + path[j][k]);                             if(check(sta)) ans = min(ans,dp[k][sta]);                         }                     }                }            }        }        if(ans==INT_MAX) ans = -1;        cout<<ans<<endl;    }    return 0;}
0 0
原创粉丝点击